<?php

# $Id: functions.inc.php,v 1.34.2.5 2007/02/13 12:53:28 jberanek Exp $

# probably a bad place to put this, but for error reporting purposes
# $pview must be defined. if it's not then there's errors generated all
# over the place. so we test to see if it is set, and if not then set
# it.

if (!isset($pview)) {
	$pview = 0;
}

//accept a @now_date as a timestamp 
//and @time string in the HH:MM:SS format and 
//returns a HH:MM:SS string represeting the 
//$now_date+$time capped to the midnight (23:59:59)
//now_date is 12:23:00 time is 6:00:00 returns 6:00:00
//now_date is 12:23:00 time is 12:00:00 returns 11:37:00
//if negative=true then value is capped to the current midnight (00:00:00)
function limitTime($now_date,$time,$negative=false){
	sscanf($time,"%d:%d:%d",$HOUR,$MINUTE,$SECOND);

	if($negative==false){
		$UPPERLIMIT=strtotime("+$HOUR hours +$MINUTE minutes +$SECOND seconds",$now_date);
	}else{
		$UPPERLIMIT=strtotime("-$HOUR hours -$MINUTE minutes -$SECOND seconds",$now_date);		
	}

	if(date("d",$now_date)!=date("d",$UPPERLIMIT)){
		if($negative==true){
			$TIME=$now_date;
		}else{
			$ORALIMITE=strtotime("$time",$now_date);
			$ORALIMITE=strtotime("-1 second",$ORALIMITE);
			$ARRAY=getdate($UPPERLIMIT);
			$TIME=strtotime("-$ARRAY[hours] hours -$ARRAY[minutes] minutes -$ARRAY[seconds] seconds",$ORALIMITE);
		}
		$TIME=strftime("%T",$TIME);
	}else{
		$TIME=$time;	
	}
	return $TIME;
}

function implodeAssoc($glue,$array){
	if(empty($array)){
		return null;
	}else{
		$tostring="";
		$array_k=array_keys ($array);
		foreach($array_k as $key){
			$tostring.="$glue$key=$array[$key]";
		}
		return $tostring;
	}
	
}
# Return a default area; used if no area is already known. This returns the
# lowest area ID in the database (no guaranty there is an area 1).
# This could be changed to implement something like per-user defaults.
function get_default_area()
{
	global $tbl_area;
	$area = sql_query1("SELECT id FROM $tbl_area ORDER BY area_name LIMIT 1");
	return ($area < 0 ? 0 : $area);
}

function getSundayStart(){
	return mktime(0,0,0,10,7,2007);
}

function convert_am7($date){
	$array=getdate($date);
	return mktime(0,0,0,$array['mon'],$array['mday'],$array['year']);
} 
function convert_pm7($date){
	$array=getdate($date);
	return mktime(23,59,59,$array['mon'],$array['mday'],$array['year']);
} 
function init_header(&$layout,$time=0,$preview=0)
{
	global $mrbs_company, $search_str, $locale_warning,$CONFIG_MRBS_HAS_POWEREDBY;
		$layout->assign("has_powered_by",$CONFIG_MRBS_HAS_POWEREDBY);
	if($time==0){
		$time=mktime();
	}
	global $refresh_rate;
	if (($refresh_rate != 0) &&
	    preg_match("/(day|week|month)\.php/",$PHP_SELF))
	{
	  $layout->assign("refresh_rate",$refresh_rate);
	}
	$layout->assign("time",$time);
	$layout->assign("showpreview",$preview);
	$layout->assign("pview",$GLOBALS["pview"]);
	if (substr(phpversion(), 0, 1) == 3){
		$layout->assign("is_phpv3",1);
	}
	if (!empty($locale_warning)){
		$layout->assign("locale_warning",1);
	}
 
   switch(basename($_SERVER['SCRIPT_FILENAME'])){
   		case 'eventiday.php':
   			$PAGE="eventiday.php";
   			break;
   		case 'month.php':
   			$PAGE='month.php';
   			break;
   		case 'day.php':
   			$PAGE='day.php';
   			break;
   		case 'week.php':
   			$PAGE='week.php';
   			break;
   		default:
   			$PAGE="day.php";
   			break;
   }
   $layout->assign("basepage",$PAGE);
   global $global_logo;
   global $global_altlogo;
   global $global_externlink;
   if($global_logo){
   		$layout->assign("global_altlogo",$global_altlogo);
   		$layout->assign("global_externlink",$global_externlink);
   		$layout->assign("global_logo",$global_logo);
   }
   $layout->assign("mrbs_company",$mrbs_company);
   if(is_numeric($area)){
   		$layout->assign("area",$area);
   }
   $layout->assign("logged",isAuthorised(1));
   $layout->assign("user",getUserName());
   $layout->assign("TargetURL",basename($_SERVER['PHP_SELF']));

    # For session protocols that define their own logon box...
    if (function_exists('PrintLogonBox'))
   	{
   		$layout->assign("haslogonbox",1);
   	}
}


function validate_date($day,$month,$year){
	if(is_numeric($day)&&is_numeric($month)&&is_numeric($year)){

		return checkdate($month,$day,$year);
	}
	return false;
}
function get_date($day,$month,$year,$time){
	$timeret=time();
	if(validate_date($day,$month,$year)){
		return mktime(0,0,0,$month,$day,$year);
	}
	if(is_numeric($time)){
		return convert_am7($time);
	}
	return convert_am7($timeret);
	
}


function toTimeString(&$dur, &$units)
{
	if($dur >= 60)
	{
		$dur /= 60;

		if($dur >= 60)
		{
			$dur /= 60;

			if(($dur >= 24) && ($dur % 24 == 0))
			{
				$dur /= 24;

				if(($dur >= 7) && ($dur % 7 == 0))
				{
					$dur /= 7;

					if(($dur >= 52) && ($dur % 52 == 0))
					{
						$dur  /= 52;
						$units = get_vocab("years");
					}
					else
						$units = get_vocab("weeks");
				}
				else
					$units = get_vocab("days");
			}
			else
				$units = get_vocab("hours");
		}
		else
			$units = get_vocab("minutes");
	}
	else
		$units = get_vocab("seconds");
}


function toPeriodString($start_period, &$dur, &$units)
{
	global $enable_periods;
        global $periods;

        $max_periods = count($periods);

	$dur /= 60;

        if( $dur >= $max_periods || $start_period == 0 )
        {
                if( $start_period == 0 && $dur == $max_periods )
                {
                        $units = get_vocab("days");
                        $dur = 1;
                        return;
                }

                $dur /= 60;
                if(($dur >= 24) && is_int($dur))
                {
                	$dur /= 24;
			$units = get_vocab("days");
                        return;
                }
                else
                {
			$dur *= 60;
                        $dur = ($dur % $max_periods) + floor( $dur/(24*60) ) * $max_periods;
                        $units = get_vocab("periods");
                        return;
		}
        }
        else
		$units = get_vocab("periods");
}



# Error handler - this is used to display serious errors such as database
# errors without sending incomplete HTML pages. This is only used for
# errors which "should never happen", not those caused by bad inputs.
# If $need_header!=0 output the top of the page too, else assume the
# caller did that. Alway outputs the bottom of the page and exits.
function fatal_error($need_header, $where,$how="",$what="")
{
	include_once SMARTY."Smarty.class.php";
	$layout=new Smarty;
	if($need_header){
		init_header(&$layout);
		$layout->assign("need_header",$need_header);
	}
	$layout->assign("where",htmlspecialchars($where));
	$layout->assign("how",htmlspecialchars($how));
	$layout->assign("what",htmlspecialchars($what));		
	$layout->display("fatal_error.html");
	exit;
}

# Apply backslash-escape quoting unless PHP is configured to do it
# automatically. Use this for GET/POST form parameters, since we
# cannot predict if the PHP configuration file has magic_quotes_gpc on.
function slashes($s)
{
	if (get_magic_quotes_gpc()) return $s;
	else return addslashes($s);
}

# Remove backslash-escape quoting if PHP is configured to do it with
# magic_quotes_gpc. Use this whenever you need the actual value of a GET/POST
# form parameter (which might have special characters) regardless of PHP's
# magic_quotes_gpc setting.
function unslashes($s)
{
	if (get_magic_quotes_gpc()) return stripslashes($s);
	else return $s;
}


# Get the local day name based on language. Note 2000-01-02 is a Sunday.
function day_name($daynumber)
{
	return utf8_strftime("%A", mktime(0,0,0,1,2+$daynumber,2000));
}


# This will return the appropriate value for isdst for mktime().
# The order of the arguments was chosen to match those of mktime.
# hour is added so that this function can when necessary only be
# run if the time is between midnight and 3am (all DST changes
# occur in this period.
function is_dst ( $month, $day, $year, $hour="-1" )
{

	if( $hour != -1  && $hour > 3)
		return( -1 );
	
	# entering DST
	if( !date( "I", mktime(12, 0, 0, $month, $day-1, $year)) && 
	    date( "I", mktime(12, 0, 0, $month, $day, $year)))
		return( 0 ); 

	# leaving DST
	elseif( date( "I", mktime(12, 0, 0, $month, $day-1, $year)) && 
	    !date( "I", mktime(12, 0, 0, $month, $day, $year)))
		return( 1 );
	else
		return( -1 );
}

# if crossing dst determine if you need to make a modification
# of 3600 seconds (1 hour) in either direction
function cross_dst ( $start, $end )
{
	
	# entering DST
	if( !date( "I", $start) &&  date( "I", $end))
		$modification = -3600;

	# leaving DST
	elseif(  date( "I", $start) && !date( "I", $end))
		$modification = 3600;
	else
		$modification = 0;

	return $modification;
}
?>
