<?php
/*****************************************************************************\
*                                                                             *
*   File name       session_php.inc.php                                           *
*                                                                             *
*   Description     Use PHP built-in sessions handling                        *
*                                                                             *
*   Notes           To use this authentication scheme, set in                 *
*                   config.inc.php:                                           *
*                       $auth["session"]  = "php";                            *
*                                                                             *
*                                                                             *
*   History                                                                   *
*    2003/11/09 JFL Created this file                                         *
*    Remaining history in ChangeLog and CVS logs                              *
*                                                                             *
\*****************************************************************************/

// $Id: session_php.inc.php,v 1.8.2.5 2007/02/13 12:53:35 jberanek Exp $

global $PHP_SELF;

if (isset($cookie_path_override))
{
    $cookie_path = $cookie_path_override;
}
else
{
    $cookie_path = $PHP_SELF;
    $cookie_path = ereg_replace('[^/]*$', '', $cookie_path);
}
session_set_cookie_params(0, $cookie_path);
session_start();

/*
  Target of the form with sets the URL argument "Action=SetName".
  Will eventually return to URL argument "TargetURL=whatever".
*/
if (isset($Action) && ($Action == "SetName"))
{
    /* First make sure the password is valid */
    if ($NewUserName == "") {

    	// Unset the session variables
    	if (isset($_SESSION)) {
            $_SESSION = array();
        } else {
            global $HTTP_SESSION_VARS;
            $HTTP_SESSION_VARS = array();
        }
    } else {
        $NewUserName = unslashes($NewUserName);
        $NewUserPassword = unslashes($NewUserPassword);
        if (!authValidateUser($NewUserName, $NewUserPassword)) {
            printLoginForm(htmlspecialchars($TargetURL),1);
            exit();
        }

        if (isset($_SESSION)) {
            $_SESSION["UserName"] = $NewUserName;
        } else {
            global $HTTP_SESSION_VARS;
            $HTTP_SESSION_VARS["UserName"] = $NewUserName;
        }
    }

    header ("Location: $TargetURL"); /* Redirect browser to initial page */
    /* Note HTTP 1.1 mandates an absolute URL. Most modern browsers support relative URLs,
        which allows to work around problems with DNS inconsistencies in the server name.
        Anyway, if the browser cannot redirect automatically, the manual link below will work. */
	$layout=new Smarty;
	init_header(&$layout);
    $layout->assign("TargetURL",htmlspecialchars($TargetURL));
    $layout->display("redirect.html");
    exit();
}

/*
  Display the login form. Used by two routines below.
  Will eventually return to $TargetURL.
*/
function printLoginForm($TargetURL,$unknowuser=0)
{
	include_once(SMARTY."Smarty.class.php");
	include_once("functions.inc.php");
	$layout=new Smarty;
	init_header(&$layout);
	if(isset($unknownuser)){
		$layout->assign("unknownuser",1);
	}
    $layout->assign("TargetURL",htmlspecialchars($TargetURL));
    $layout->display("loginform.html");
}

/*
  Target of the form with sets the URL argument "Action=QueryName".
  Will eventually return to URL argument "TargetURL=whatever".
*/
if (isset($Action) && ($Action == "QueryName"))
{
    printLoginForm(htmlspecialchars($TargetURL));
    exit();
}

/* authGet()
 * 
 * Request the user name/password
 * 
 * Returns: Nothing
 */
function authGet()
{
    global $PHP_SELF, $QUERY_STRING;
    $TargetURL=htmlspecialchars(basename($PHP_SELF));
    if (isset($QUERY_STRING)) $TargetURL = $TargetURL . "?" . $QUERY_STRING;
    printLoginForm($TargetURL);

    exit();
}

function getUserName()
{
    if (isset($_SESSION) && isset($_SESSION["UserName"]) && ($_SESSION["UserName"] != ""))
    {
        return $_SESSION["UserName"];
    }
    else
    {
        global $HTTP_SESSION_VARS;
        if (isset($HTTP_SESSION_VARS["UserName"]) && ($HTTP_SESSION_VARS["UserName"] != ""))
            return $HTTP_SESSION_VARS["UserName"];
    }
}

// Print the logon entry on the top banner.
function PrintLogonBox()
{
}
?>
